@echo off
echo ---------------------- BUILD SCRIPT ----------------------
rem
echo    DC++ Batch Build Script Version 0.1.1
rem
echo ---------------------- BUILD SCRIPT ----------------------
echo Loading settings
rem ---------------------- SEPARATOR ----------------------
rem
rem	CONFIGURATION - SET YOUR PATHS BELOW
rem
rem ---------------------- SEPARATOR ----------------------
set zip=%PROGRAMFILES%\7-Zip\7z.exe
set dcpp=F:\dcdev_stuff\bzr\dcplusplus\
set nightly_builds=F:\dcdev_stuff\bzr\nightly_builder\
set mingw_debug=F:\dcdev_stuff\bzr\dcplusplus\build\debug-mingw\bin\
set mingw_release=F:\dcdev_stuff\bzr\dcplusplus\build\release-mingw\bin\
set msvc_debug_86=F:\dcdev_stuff\bzr\dcplusplus\build\debug-default\bin\
set msvc_release_86=F:\dcdev_stuff\bzr\dcplusplus\build\release-default\bin\
set msvc_debug_64=F:\dcdev_stuff\bzr\dcplusplus\build\debug-default-x64\bin\
set msvc_release_64=F:\dcdev_stuff\bzr\dcplusplus\build\release-default-x64\bin\
set export_mingw=F:\dcdev_stuff\shared\dcpp\nightly_builds\mingw_builds\
set export_msvc=F:\dcdev_stuff\shared\dcpp\nightly_builds\msvc_builds\
set export_source=F:\dcdev_stuff\shared\dcpp\nightly_builds\source\
rem ---------------------- SEPARATOR ----------------------
rem
rem	CONFIGURATION - END OF CONFIG
rem
rem ---------------------- SEPARATOR ----------------------
echo Checking for updates
cd %dcpp%
call bzr pull lp:dcplusplus
call bzr revno > ..\bzr-revno.txt
set /p dcpp-revno= < ..\bzr-revno.txt
del F:\dcdev_stuff\bzr\bzr-revno.txt
echo reversion number: %dcpp-revno%
pause
cls
echo Beginning compiling script
echo on
call scons help=0
if errorlevel 1 goto end
echo on
call scons mode=release help=0
if errorlevel 1 goto end
echo on
call scons tools=default help=0
if errorlevel 1 goto end
echo on
call scons tools=default mode=release help=0
if errorlevel 1 goto end
echo on
call scons tools=default arch=x64 help=0
if errorlevel 1 goto end
echo on
call scons tools=default mode=release arch=x64 help=0
if errorlevel 1 goto end
@echo off
cls
echo Removing unnessary files and copying nessary files and stripping executables
call strip %mingw_debug%DCPlusPlus.exe
call strip %mingw_release%DCPlusPlus.exe
call strip %msvc_debug_86%DCPlusPlus.exe
call strip %msvc_release_86%DCPlusPlus.exe
call strip %msvc_debug_64%DCPlusPlus.exe
call strip %msvc_release_64%DCPlusPlus.exe
cd %msvc_debug_86%
del /S *.exp
del /S *.lib
cd %msvc_release_86%
del /S *.exp
del /S *.lib
cd %msvc_debug_64%
del /S *.exp
del /S *.lib
cd %msvc_release_64%
del /S *.exp
del /S *.lib
pause
cls
cd %dcpp%
copy changelog.txt %mingw_debug%
copy changelog.txt %mingw_release%
copy changelog.txt %msvc_debug_86%
copy changelog.txt %msvc_release_86%
copy changelog.txt %msvc_debug_64%
copy changelog.txt %msvc_release_64%
copy License.txt %mingw_debug%
copy License.txt %mingw_release%
copy License.txt %msvc_debug_86%
copy License.txt %msvc_release_86%
copy License.txt %msvc_debug_64%
copy License.txt %msvc_release_64%
copy dcppboot.xml %mingw_debug%
copy dcppboot.xml %mingw_release%
copy dcppboot.xml %msvc_debug_86%
copy dcppboot.xml %msvc_release_86%
copy dcppboot.xml %msvc_debug_64%
copy dcppboot.xml %msvc_release_64%
copy LICENSE-GeoIP.txt %mingw_debug%
copy LICENSE-GeoIP.txt %mingw_release%
copy LICENSE-GeoIP.txt %msvc_debug_86%
copy LICENSE-GeoIP.txt %msvc_release_86%
copy LICENSE-GeoIP.txt %msvc_debug_64%
copy LICENSE-GeoIP.txt %msvc_release_64%
copy LICENSE-OpenSSL.txt %mingw_debug%
copy LICENSE-OpenSSL.txt %mingw_release%
copy LICENSE-OpenSSL.txt %msvc_debug_86%
copy LICENSE-OpenSSL.txt %msvc_release_86%
copy LICENSE-OpenSSL.txt %msvc_debug_64%
copy LICENSE-OpenSSL.txt %msvc_release_64%
copy mingwm10.dll %mingw_debug%
copy mingwm10.dll %mingw_release%
copy GeoIPCountryWhois.csv %mingw_debug%
copy GeoIPCountryWhois.csv %mingw_release%
copy GeoIPCountryWhois.csv %msvc_debug_86%
copy GeoIPCountryWhois.csv %msvc_release_86%
copy GeoIPCountryWhois.csv %msvc_debug_64%
copy GeoIPCountryWhois.csv %msvc_release_64%
cd %nightly_builds%
copy *.url %mingw_debug%
copy *.url %mingw_release%
copy *.url %msvc_debug_86%
copy *.url %msvc_release_86%
copy *.url %msvc_debug_64%
copy *.url %msvc_release_64%
pause
cls
if not exist "%zip%" (
   echo 7zip isnt found make sure path is correct, exiting...
   pause
   exit
)
echo 7zip is found going ahead with compression for the builds
echo compressing dcpp into archives
cd %mingw_debug%
call "%zip%" a dcpp_rev_%dcpp-revno%_mingw_debug_version.zip
cd %mingw_release%
copy *.zip "%export_mingw%"
call "%zip%" a dcpp_rev_%dcpp-revno%_mingw_release_version.zip
copy *.zip "%export_mingw%"
cd %msvc_debug_86%
call "%zip%" a dcpp_rev_%dcpp-revno%_msvc_debug_x86_version.zip
copy *.zip "%export_msvc%"
cd %msvc_release_86%
call "%zip%" a dcpp_rev_%dcpp-revno%_msvc_release_x86_version.zip
copy *.zip "%export_msvc%"
cd %msvc_debug_64%
call "%zip%" a dcpp_rev_%dcpp-revno%_msvc_debug_x64_version.zip
copy *.zip "%export_msvc%"
cd %msvc_release_64%
call "%zip%" a dcpp_rev_%dcpp-revno%_msvc_release_x64_version.zip
copy *.zip "%export_msvc%"
cd %dcpp%
echo Compressing Source
call bzr export dcpp_rev_%dcpp-revno%_source.tar.gz
copy dcpp_rev_%dcpp-revno%_source.tar.gz "%export_source%"
cls
rem ---------------------- SEPARATOR ----------------------
rem
rem	FTP IS DISABLED PER DEFAULT JUST REMOVE THE REM COMMENT
rem
rem ---------------------- SEPARATOR ----------------------
rem echo uploading distrobution to ftp
rem call ftp.exe -s:dcpp_login.ftp
echo removing builds builds for dcpp
del dcpp_rev_%dcpp-revno%_source.tar.gz
del .sconsign.dblite
del vc90.pdb
echo on
call scons -c
echo on
call scons mode=release -c
echo on
call scons tools=default -c
echo on
call scons tools=default mode=release -c
echo on
call scons tools=default arch=x64 -c
echo on
call scons tools=default mode=release arch=x64 -c
exit